/**
*  AttributeWatcher is responsible for the subscription/publication of
*  all the attributes of particular class. It will registers all the puiblishing
*  activities and broadcast this all the subscribed federates.
*
*/

import RTIcap.*;
import java.util.*;

/**
*/
public class AttributeWatcher implements RTIDebug
{
   ObjectRecord father;      // Object 
   short        theHandle;
   String       theName;
   Hashtable    subscribers = new Hashtable();  // Subscribers
   Hashtable    publishers  = new Hashtable();  // Publishers

   /**
   *
   */
   public
   AttributeWatcher(ObjectRecord _boss, short _theHandle, String _theName) 
   { 
       father = _boss;
       theHandle = _theHandle;
       theName   = _theName;

   }// end of CONSTRUCTOR

   /**
   *
   */
   public void
   subscribe(RTIcap.FederateAmbassador _fedAmb, short fedHandle)
   {
      subscribers.put(new Short(fedHandle),_fedAmb);
      if(DEBUG) System.out.println(fedHandle+" is added to list of "+theName);

   }// end of subscribe()

   /**
   *
   */
   public void
   unsubscribe(short fedHandle)
   {
      subscribers.remove(new Short(fedHandle));

   }// end of subscribe()

   /**
   *
   */
   public void
   publish(short sourceFed)
   {

      Enumeration e = subscribers.keys();
      for(;e.hasMoreElements();)
      {
         Short key = (Short) e.nextElement();
         FederateAmbassador n = (FederateAmbassador) subscribers.get(key);

         if(n!=null && key.shortValue()!=sourceFed) {};

      }// end of for

   }// end of publish()

   /**
   *
   */
   public void
   register_publisher(FederateAmbassador _fedAmb, short fedHandle)
   {
    
      FederateAmbassador n = (FederateAmbassador) publishers.get(new Short(fedHandle));
   
      if(n==null) 
      { 
         publishers.put(new Short(fedHandle),_fedAmb);
         if(DEBUG) System.out.println(fedHandle+" is added to publisher list of "+theName);
      } 
      
   }// end of register_publisher()

   /**
   *
   */
   public void
   deregister_publisher(short fedHandle)
   {
    
      FederateAmbassador n = (FederateAmbassador) publishers.get(new Short(fedHandle));
   
      if(n==null) publishers.remove(new Short(fedHandle));
      
   }// end of register_publisher()

   /**
   */
   public void
   broadcast( int theObject, RTIcap.AttributeHandleValuePair att, double theTime, 
              String theTag, FederateAmbassador _fedHandle, short _fedId )
              throws RTIcap.FederateInternalError, RTIcap.ObjectNotKnown ,
                     RTIcap.InvalidFederationTime, RTIcap.AttributeNotKnown
                     
   {
      if(DEBUG) System.out.println(" in broadcast() message from "+_fedId);
      /** It has to be publisher Federate */

      FederateAmbassador ret = (FederateAmbassador) publishers.get(new Short(_fedId));
     

      if(ret!=null)
      {
         RTIcap.AttributeHandleValuePair attSet[] = new RTIcap.AttributeHandleValuePair[1];
         attSet[0] = att;

         RTIcap.EventRetractionHandle retract = new RTIcap.EventRetractionHandle(theTime,0,_fedId);

         Enumeration e = subscribers.keys();
         for(;e.hasMoreElements();)
         {
            Short key = (Short) e.nextElement();
            FederateAmbassador n = (FederateAmbassador) subscribers.get(key);

            if(n!=null && key.shortValue()!=_fedId) 
            {
               //n.reflectAttributeValues(father.getId(),attSet,theTime,theTag,retract);
               n.reflectAttributeValues(theObject,attSet,theTime,theTag,retract);
               if(DEBUG) System.out.println(" I sent to "+key.shortValue());

            }// end of if

         }// end of for

      }// end of if
      if(DEBUG) System.out.println(" out of broadcast() ");

   }// end of broadcast()

}// end of class AttributeWatcher

